"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _less = require("less/lib/less/");

var _less2 = _interopRequireDefault(_less);

var _Variable = require("../tree/Variable");

var _Variable2 = _interopRequireDefault(_Variable);

var _Condition = require("../tree/Condition");

var _Condition2 = _interopRequireDefault(_Condition);

var _Negative = require("../tree/Negative");

var _Negative2 = _interopRequireDefault(_Negative);

var _Dimension = require("../tree/Dimension");

var _Dimension2 = _interopRequireDefault(_Dimension);

var _functions = require("../functions");

var functions = _interopRequireWildcard(_functions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

exports.default = function (source) {
    var less = new _less2.default();
    Object.defineProperty(less.tree.Node.prototype, 'parse', {
        set: function set(self) {
            var parseJS = function parseJS(orig) {
                var val = orig();
                if (val) return val;

                var name = void 0;
                self.parserInput.save();
                if (self.parserInput.currentChar() === '$' && (name = self.parserInput.$re(/^\${[\s\S]*?}/))) {
                    var anonymous = new less.tree.Anonymous(name, self.parserInput.i, self.fileInfo);
                    anonymous.noSpacing = self.parserInput.prevChar() !== " ";
                    return anonymous;
                }
                self.parserInput.restore();
            };

            self.parsers.declaration = parseJS.bind(null, self.parsers.declaration.bind(self.parsers));
            self.parsers.entities.variable = parseJS.bind(null, self.parsers.entities.variable.bind(self.parsers));
        },
        configurable: true
    });
    less.tree.Variable = _Variable2.default;
    less.tree.Condition = _Condition2.default;
    less.tree.Negative = _Negative2.default;
    less.tree.Dimension = _Dimension2.default;
    less.tree.Expression.prototype.genCSS = function (context, output) {
        for (var i = 0; i < this.value.length; i++) {
            this.value[i].genCSS(context, output);
            if (!(this.noSpacing || this.value[i].noSpacing) && i + 1 < this.value.length) {
                output.add(' ');
            }
        }
    };
    less.tree.Anonymous.prototype.eval = function () {
        var anonymous = new less.tree.Anonymous(this.value, this._index, this._fileInfo, this.mapLines, this.rulesetLike, this.visibilityInfo());
        anonymous.noSpacing = this.noSpacing;
        return anonymous;
    };
    less.functions.functionRegistry.addMultiple(functions);
    less.PluginLoader = function PluginLoader() {
        _classCallCheck(this, PluginLoader);
    };

    var root = void 0,
        imports = void 0,
        options = void 0;
    less.parse(source, { math: 0 }, function (e, _root, _imports, _options) {
        if (e) {
            console.error(e);
        }
        root = _root;
        imports = _imports;
        options = _options;
    });
    if (!root) {
        console.error("Failed to parse", source);
        return source;
    }
    // Disables the validation: Properties must be inside selector blocks. They cannot be in the root
    root.firstRoot = false;

    var parseTree = new less.ParseTree(root, imports);

    var _parseTree$toCSS = parseTree.toCSS(options),
        css = _parseTree$toCSS.css;

    return css;
};